<?php include "/var/www/shared/local.php"; ?>
<?php
//
// `cp is.php $APP/$APP.php` (used as a base to derive application-specific $is data structure).
//

/* This is a base example Information Structure file to derive your own from.
 * Copy this to .../ops/is/$NAME/$NAME.php, modify it with your own data structure(s).
 * It should be enough to specify an SQL table structure given a few good defaults,
 * and as populated through the octopus of a web app to be a data
   structure with named/typed elements.
 */
 
  $is =  [

/*
Each Tx has reporter (A|B)
     	    from|payer (C|D|E|F|G|H|I)
     	    to|payee (same)
	    rate
	    quantity
	    amount
	    class (description) (rent|services|reimbursement)
	    comment (message)
	    date-due
	    invoice # (YYMM[ABCR] for rent invoices)
	    date-paid
	    date-deposited
*/
  $is =  [
          "Name" => "$APP",
          "URL" =>  "https://<?php echo "$homehost";?>.com",
          "User" => "public_user", // crud ops only on this table within the 'tv' database.
          "Pwd" =>  "HaveYourOwn", 
          "Path" => "is/$APP",
	  "BackupDir"=>"~/.mysql_backup/", // backup directory
	  "BackupDate" =>"20230619",      // specify B/backup.(BDate).sql to restore from
	  "DBName" => "APP",              // one DB could also have many single-table APPs in it.
	  "TableName" =>  "$APP",
	  "Columns" =>  [  // here is a range of examples I've used or looked up, pick some or make your own.
	    // [ col#, colName,    colType,     N,    def,  inputType, SQLType        ]
   	       [    1, "id",       "Number",    1,     -1,   "hidden", "INT AUTO_INCREMENT PRIMARY KEY"  ], 
	       [    2, "reporter", "By",        1,     "",   "select", "ENUM('CK','TV','TTS')" ],
	       [    3, "payer",    "From",      1,     "",   "select", "ENUM('A','B','C','D')" ],
               [    4, "payee",    "To",        1,     "",   "select", "ENUM('A','B','C','R')" ],
               [    5, "orig_payee","For",      1,     "",   "select", "ENUM('A','B','C','R')" ],
               [    6, "amount",   "Dollars",   1,      0,   "money", "INT DEFAULT 0" ],
               [    7, "tx_class", "Enum",      1,     "",   "select", "ENUM('rent','fee','services','reimbursement')" ],
               [    9, "tx_desc",  "String",   20,     "",     "TEXT", "VARCHAR(40) CHARACTER SET utf8" ],
               [   10, "invoiceNo","String",   20,"YYMMX",     "TEXT", "VARCHAR(10) CHARACTER SET utf8" ],
               [   11, "date_due",      "date", 1,     "",     "date", "DATE" ],
               [   12, "date_paid",     "date", 1,     "",     "date", "DATE" ],
               [   14, "created_at",    "time", 1,   NULL,   "hidden", "TIMESTAMP DEFAULT CURRENT_TIMESTAMP" ],
               [   15, "updated_at",    "time", 1,   NULL,   "hidden", "TIMESTAMP ON UPDATE CURRENT_TIMESTAMP" ],
	       [   16, "TestN",      "Number",  1,     -1,   "number", "SMALLINT DEFAULT -1" ],
               [   17, "TestS",      "String", 20,     "",     "TEXT", "VARCHAR(20) CHARACTER SET utf8" ],
               [   18, "TestB",      "Boolean", 1,      1, "checkbox", "BIT"     ], // checkbox|radio
               [   19, "TestE",         "Enum", 1,      1,   "select", "ENUM('val1','val2','val3')" ] 
               [   20, "TxTime",        "Date", 1,      0,   "hidden", "TIMESTAMP DEFAULT CURRENT_TIMESTAMP" ],
	     ],
	  "Adds"     => [    // [    7, "TestD","Date",    1,   0,     "date", "DATETIME DEFAULT CURRENT_TIMESTAMP" ]
	  	     // If you are going to make a change in a table adding a column,
		     // then use this in $is$NAME.db modify_table first, then move
		     // Adds into Columns to reflect new reality.
		     ],
          "Criteria" =>  "An SQL substring to use in a SELECT WHERE command"
  ];  // PHP syntax. convert with json_encode($is) if needed.
  
/* colType is an informative label for the corresponding Create/Edit widget along with colName.
   inputType is used for the type parameter in HTML form <input type=$inputType>'s and <select>'s,
     and are one of these:
     color, date, datetime-local, email, file, hidden, image, month, number, password,
     range, tel, text, time, url, week.  (I don't see how button, checkbox,
     radio, reset, search, or submit could be apropos, so I'm ignoring them.)
   columm SQL Type is any (My)SQL variable type declaration.
     From the MySQL pages, for example:
       Number types are the MySQL numeric types:
         BIT, (TINYINT(1)|BOOLEAN), (INT|INTEGER), SMALLINT, DECIMAL|DEC|FIXED), NUMERIC;
         FLOAT, (REAL|DOUBLE|DOUBLE PRECISION), 
       String types are CHAR, VARCHAR(len), BINARY, VARBINARY, BLOB, TEXT, ENUM, and SET.
       Temporal types include: DATE, TIME, DATETIME, TIMESTAMP, and YEAR.
     Furthermore: you can append stuff like:
       DEFAULT 'x' to set a default value for that colummn, too.
       NOT NULL to require it have some value (implied by PRIMARY KEY)
       AUTO_INCREMENT to count up the next value
       UNIQUE to make sure values in the column are unique (implied by PRIMARY KEY)
 */
?>
