<?php include "/var/www/shared/local.php"; ?>
<?php
//
// isapijs.php
// 

/* This program uses an IS data structure (in $NAME.php) to
   autogenerate a JS-includeable library/function file that provides
   an authenticated client-side API for IS CRUD operations. 

   To use it:
   % php isapijs.php $NAME > isapi.js

or from a browser:
   http:path.to.here/isapijs.php$NAME=yourtablename > isapi.js
 */

$debug=0;
if (defined('STDIN')) { $NAME=$argv[1];      }
else                  { $NAME=$_GET['NAME']; }
include "$NAME/$NAME.php";

echo "/* start JS library file based on $NAME.php */\n";
?>
  //
  // This file is autogenerated by php isapijs.php <?php echo $NAME;?>.
  // JS code provides an IS API over HTTP through the server's REST-ish CRUD
  // ops (in PHP) and ultimately the server's DB for table <?php echo $NAME;?>
  //

<?php
  echo "debug=$debug;";
 ?>

function is(op,server,json,onload) {
  if      (op=="search") { return isSearch(server,json,onload); }
  else if (op=="create") { return isCreate(server,json,onload); }
  else if (op=="read"  ) { return isRead(  server,json,onload); }
  else if (op=="update") { return isUpdate(server,json,onload); }
  else if (op=="delete") { return isDelete(server,json,onload); }
  else                   { return false;                        }
}

function isSearch(server,json,onload) {
  alert("called isSearch(" + server + "," + json + ",onload)");
  const xhr = new XMLHttpRequest();
  xhr.open("POST",server,true);  // was GET.  content in body or in URI?
  // message body (json content) deprecated in http GET requests.
  // So either put it in the URI and use GET or put it in the body and use POST.
  // Discussion: 
  // https://stackoverflow.com/questions/978061/http-get-with-request-body
  // esp. "GET, with a body!? which points out the meaning of GET vs POST is to retrieve, and
  // that such searches may provide a programmatic view of database records,
  // that this might be bad to reveal in the URI.
  // However a (JSON) body with GET was once prohibited and proxy 
  // servers may delete the JSON in transit.
  // So the preferred approach is to do SEARCH via POST with $URL with op=SEARCH, 
  // and body JSON for search params.
  // POST + op=SEARCH is a "safe" (no side effects), and idempotent (repeatable
  // without changing outcome of cumulated side effects).

  msg = "in isSearch(): JSON='" + json + "', server=" + server;
  console.log(msg);
  xhr.onload = onload;

  // xhr.setRequestHeader("Content-Type","application/json; charset=utf-8");
  // xhr.setRequestHeader("Content-Length",json.length);

  xhr.setRequestHeader("Access-Control-Allow-Origin",server);
  xhr.setRequestHeader("Access-Control-Allow-Methods","POST"); // was GET, see above.
  xhr.setRequestHeader('Accept','application/json');
  xhr.send(json);
  // alert("isSearch(): xhr.send(POST " + json + ") sent to url " + server);
  return false; // return false or do destructive page reload
}

function isCreate(server,json,onload) {
  const xhr = new XMLHttpRequest();
  xhr.open("POST",server,true); // POST adds a new row to the table
  msg = "in isCreate(), form data|JSON=" + json + ", server=" + server;
  console.log(msg);
  xhr.onload = onload;
  xhr.setRequestHeader("Content-Type","application/json; charset=utf-8");
  xhr.setRequestHeader("Access-Control-Allow-Origin",server);
  xhr.setRequestHeader("Access-Control-Allow-Methods","POST,PUT");
  xhr.send(json);
  if (debug) alert("isCreate(): xhr.send(POST " + json + ") sent to url " + server);
  return false; // return false or do destructive page reload
}


function isRead(server,json,onload) {
  // HOWTO 06 isapi.js defines is$OP() to AJAX-query server with json and callback using an XMLHttpRequest
  const xhr = new XMLHttpRequest();
  // const debug = false;
  xhr.overrideMimeType("application/json");
  xhr.open("GET",url,true); // 
  msg = "in isRead(" + server + ",json=" + json + ",onload)";
  console.log(msg);
  xhr.onload = onload;
  xhr.setRequestHeader("Content-type","application/json; charset=utf-8"); // on send or load?
  xhr.setRequestHeader("Access-Control-Allow-Origin",server); // added, taken from isSearch()
  xhr.setRequestHeader("Access-Control-Allow-Methods","GET"); // added, taken from isSearch()
  xhr.send("");
  if (debug) alert("isRead(): xhr.send([Empty body]) sent to " + url);
  return false; // we don't need a whole page reload after all this work.
}

function isUpdate(server,json,onload) {
  const xhr = new XMLHttpRequest();
  // const debug = false;
  xhr.open("PUT",url,true); // PUT: we know where it gets PUT so it's an update, 
                            // whereas POST would add a new row to the table
  msg = "in isUpdate(), form data|JSON=" + json + ", url=" + url;
  console.log(msg);
  xhr.onload = onload;
  xhr.setRequestHeader("Content-type","application/json; charset=utf-8");
  xhr.setRequestHeader("Access-Control-Allow-Origin","<?php echo "$is[URL]/$is[Path]/$is[Name]/"; ?>");
  xhr.setRequestHeader("Access-Control-Allow-Methods","PUT");
  xhr.send(json);
  if (debug) alert("isUpdate(): xhr.send(" + json + ") sent.");
}

/* Not presently in use.  Why? See is$APP.js:is_$APP_delete comments. 
  function isDelete(server,json,onload) {  
    const xhr = new XMLHttpRequest();
    // const debug = false;
    xhr.open("DELETE",server,true); // check DELETE privs on server in is$is[Name].php
    msg = "in isDelete(), id=" + json;
    console.log(msg);
    xhr.onload = onload;
    xhr.setRequestHeader("Content-type","application/json; charset=utf-8");
    xhr.send(json);
    if (debug) alert("isDelete(): xhr.send(" + json + ") sent.");
    return false; // false here prevents form submission after onload i.e. full page reload.
  }
*/
