<?php include "/var/www/shared/local.php"; ?>
<?php
//
// isdb.php:
//

  /* This program uses an IS data structure (in $NAME.php) to
     autogenerate (via PHP self-rewriting code) a set of IS MySQL commands
     to set up, grow, shrink, maintain, backup,
     and to access (via a SCRUD API called from server side PHP) a database.
     The actual access commands are found in 
   */
  $debug=0;
  
  if (defined('STDIN')) { $NAME=$argv[1];      }
  else                  { $NAME=$_GET['NAME']; }
  include "$NAME/$NAME.php";
  if ($debug) echo "is[User]=" . $is['User'] . "\n";
  
  $pfx = "mysql -u" . $is['User'] . " -p" . $is['Pwd'] . " ";
  $rpfx = "cpanel->phpMyAdmin->SQL->";

  if (isset($is['BackupDate'])) {
    $d = $is['BackupDate'];
  } else {
    $d = date("Ymd");
  }

  // might need a JSON record to be inserted.  { fea = val; ... }
  $insertData = '{"fea1":"val1","fea2":"val2","fea3":"val3"}';
  if ($debug)
    echo "insertData=$insertData\n";
  $rec = json_decode($insertData,true);
  if ($debug)
    echo "rec=";
  if ($debug)
    var_dump($rec);
  $features = join(",",array_keys($rec));
  $values = join(",",array_values($rec));
  // $whereclause = "($features) VALUES ($values)";

?>
#/bin/bash

if [ "$#" -ne 1 ]; then
  echo Usage: $0 CMD
  echo "where CMD is one of: "
  echo "  create_user"
  echo "  create_db"
  echo "  backup_db"
  echo "  restore_db"
  echo "  create_table"
  echo "  modify_table"
  echo "  create"
  echo "  read"
  echo "  update"
  echo "  delete"
  echo "  privilege_user"
  exit 2
fi

if   [ $1 == "create_user" ]; then
  echo "First create a MySQL DB, then create a MySQL user with privileges on that DB.";
  echo ""
  echo "If you control a MySQL DB using cpanel, try cpanel->phpMyAdmin"
  echo "Alteratively cpanel->MySQL DB Wizard->Create DB Test";
  echo " followed by Create USER admin with all privileges, then user public_user with CRUD privileges for each table";
  echo " via: cpanel->MySQL DB Wizard->Create User public_user, ";
  echo "  password ...->privileges DELETE INSERT SELECT UPDATE";
  echo ""
  echo "Also see is.php.  Or...";
  echo ""
  echo "If you don't use cpanel, do it through mysql's command-line interface:"
  echo "% mysql -u admin -p, or % sudo mysql"
  echo "password: <enter password>"
  echo "mysql> CREATE USER 'username'@'localhost' IDENTIFIED BY 'password';"
  echo "mysql> GRANT ALL PRIVILEGES ON * . * TO 'username'@'localhost';"
  echo ' or (CRUD): INSERT SELECT UPDATE DELETE'
  echo ' or (only a certain    db like tv    ): .. ON tv.*   TO ..'
  echo ' or (only a certain table like tv.APP): .. ON tv.APP TO ..'
  echo "mysql> FLUSH PRIVILEGES;"
  echo "mysql> SHOW GRANTS FOR 'username'@'localhost';"
  echo "mysql> QUIT;"
  echo "% mysql -u username -p   # test if it works."
  echo ""
  echo 'Later, after creating database tv and table App (or whatever you '
  echo 'name them), you can see your App data with: '
  echo "mysql> USE tv; SELECT * FROM App;"
  echo ""

elif [ $1 == "create_db" ]; then

  # Context of use: One time only, by the administrator, perhaps also inside the restore operation from a backup.
  
  echo "First create a DB, then give users privileges on it.";
  echo "sudo mysql"
  echo "mysql> CREATE DATABASE tv CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci;"
  echo "mysql> USE tv; # or YourDBName"
  echo "First create a DB, then give users privileges on it.";
  echo "mysql> GRANT INSERT SELECT, UPDATE ON * . * TO 'username'@'localhost';"
  echo '       (Is that too much? Do that per table after each table creation instead?!)'
  echo '       (Is that enough?  What mysql user does table creation?!)'
  echo 'This server-user privileges model is separate from the IS security model which is for web-users.'
  echo 'server users are  in MySQL->system->users; web accounts are in (in my case) MySQL->tvuserdb->users'
  echo 'Website SCRUD operation privileges for different APPs given in tvuserdb->users->privs'
  echo 'as a string of app/priv values (comma-separated) (APP:PRIV*)*, where the apps are your apps,'
  echo "and the privileges are compatible subsets of ADMIN,NONE,ALL,SEARCH,CREATE,READ,UPDATE,DELETE"
  echo '(ALL includes the SCRUD options and exclude NONE and ADMIN,'
  echo ' NONE would be incompatible with having other options given - behavior unspecified/unsafe'
  echo ' and ADMIN is intended to include sysadmin privileges beyond SCRUD such as table creates/mods)'
  echo ""

elif [ $1 == "backup_db" ]; then

# Context of use: periodically by a cron job
  # Back up just the db in $NAME.php
  echo "Do this: <?php echo "% mysqldump -u=" . $is['User'] . " -p=" . $is['Pwd'] . " --databases " . $is['DBName'] . " > " . $is['BackupDir'] . "backup.$d.sql"; ?>";
  echo ""
  
elif [ $1 == "restore_db" ]; then

  # Context of use: after a disaster or infrastructure change by the admin.
  # restore the backup specified by BDate in $NAME.php
  
  echo "Do this: <?php echo "% mysql < $is[BackupDir]backup.$is[BackupDate].sql"; ?>";
  echo ""

elif [ $1 == "create_table" ]; then

  # You can use cpanel->MySQL DB Wizard to do administrative ops like creating &
  # dropping DBs.  Hopefully as mere user username you can create/drop tables.
  # whereas as user public_user you can only do CRUD ops on these tables.

  # Context of use: Once only, by the app developer, perhaps again to rebuild.
  echo "<?php
         $table_create_command = "CREATE TABLE IF NOT EXISTS \`" . $is['TableName'] . "\` ( \n\t";
	 foreach( $is['Columns'] as list( $id, $colName, $type, $N, $def, $InputType, $SQL_Type )) {
	   if ( $id != "1" ) {
	     $table_create_command .= ", \n\t";
	   }
	   $table_create_command .= $colName . " "; // column name
	   $table_create_command .= $SQL_Type; // column MySQL data type
         }
	 $table_create_command .= "\n) ENGINE=INNODB;\n";
	 echo "$rpfx $table_create_command"; 
    ?>";

   echo "To see Collation which for utf8 better named utf8mb4, "
   echo 'Should show as utf8mb4_0900_ai_ci or utf8_unicode_520_ci or utf8_unicode_ci (1st is best)'
   echo "do mysql> SHOW TABLE STATUS LIKE 'App';"  
   echo ""


elif [ $1 == "modify_table" ]; then
  # Context of use: by developer when the app changes and needs another column.
  echo "sudo mysql"
  echo 'mysql> use tv;  # Or $YourDB'
  echo "       Generally:"
  echo "mysql> ALTER TABLE $YourDB.$APP ADD $colName $SQL_Type;"
  echo "       Or for a concrete example: "
  echo "mysql> ALTER TABLE tv.Water ADD    TestD DATETIME DEFAULT CURRENT_TIMESTAMP;"
  echo "       Confirm the new column has what you like:"
  echo "mysql> describe Water;"
  echo "       If you do not like, then MODIFY it, for example like this::"
  echo "mysql> ALTER TABLE tv.Water MODIFY TestD DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL;"
  echo "mysql> describe Water;"
  echo ""
  echo "The following is an ALTER TABLE command using the data in your ADDs list from $is[TableName].php"
  echo ""
  echo "<?php
          $table_modify_command = "";
          foreach ($is['Adds'] as list( $id, $colName, $type, $N, $def, $InputType, $SQL_Type )) {
            $table_modify_command .= "ALTER TABLE $is[DBName].$is[TableName] ADD "
			  . $colName . " "    // column name
			  . $SQL_Type . ";\n"; // column MySQL data type
          }
          echo "$rpfx $table_modify_command"; 
    ?>";

elif [ $1 == "create" ]; then
  # Context of use: by the app itself when used by a client
  echo "<?php echo $pfx; ?> INSERT INTO TABLE $is[DBName].$is[TableName]$rec[Insert];";
  echo ""

elif [ $1 == "read" ]; then
  # Context of use: by the app itself when used by a client
  # expecting features to be "*" or a joined subset of column names.
  # expecting SelectString to look like "WHERE id=23" or some other search criteria
  echo "<?php echo "$pfx SELECT " . ($features?$features:"*") . " FROM $is[DBName].$is[TableName] SelectString;"; ?>";
  echo ""

elif [ $1 == "search" ]; then
  echo "<?php echo "$pfx SELECT " . ($features?$features:"*") . " FROM $is[DBName].$is[TableName] SelectString;"; ?>";

elif [ $1 == "update" ]; then
  echo 'Context of use: by the app itself when used by a client'
  echo 'expecting UpdateString looks like "SET col1 = val1, col2 = val2, ... WHERE [condition]"'
  echo "<?php echo "$pfx UPDATE TABLE $is[DBName].$is[TableName] UpdateString;"; ?>";
  echo ""

elif [ $1 == "delete" ]; then
  # Context of use: by the app itself when used by a client
  # expecting DeleteString looks like "WHERE `id` = 32"
  echo "<?php echo "$pfx DELETE FROM TABLE $is[DBName].$is[TableName] DeleteString;"; ?>";
  echo ""

elif [ $1 == "privilege_user" ]; then
  echo "sudo mysql tvuserdb"
  echo "enter password"
  echo "use tvuserdb;"
  echo "ALTER TABLE users ADD COLUMN privs VARCHAR\(128\) NOT NULL DEFAULT 'NONE';"
  echo "UPDATE users set privs APP:PRIV,PRIV,PRIV or APP:NONE or APP:PRIV;APP:PRIV,PRIV or etc. WHERE `id`=userid;"
  echo ""

else
  echo "Argument $1 not recognized. Please try again.";
  echo ""

fi

exit
