<?php include "/var/www/shared/local.php"; ?>
<?php
  //
  // isindex.php
  //

  /* Here's a template index.php file for an IS SCRUD page 

     This program uses an IS data structure (in $NAME.php) to
     autogenerate a sample index.php file with an IS SCRUD UI.
     To use it:
     % php isindex.php $APP $TABLE > $APP/index.php
   */
  $debug=1;
  if (defined('STDIN')) { $APP=$argv[1]; $TABLE=$argv[2];      }
  else                  { $NAME=$_GET['NAME'];$APP=$_GET['APP'];$TABLE=$_GET['TABLE']; }
  include "$APP/$TABLE.php";
  
echo <<<'EOD'
<?php

$debug = 0;
 
/* ********************************************************************************
                      is/$APP design discussion:
   ********************************************************************************

   Two approaches: JS+Ajax vs PHP whole pages, modularized on the server.

   Presently it doesn't seem worthwhile to do the whole JS Ajax thing.
     I'll have to re-learn AJAX, Angular, etc.
     Let there be, for each form's action, a PHP handler.
     Server-side PHP includes to do the DB I/O.

   But, JS+Ajax already half exists here.  Maybe we'll have to use it.

   SCRUD Operations are: Search, Create, Read, Update, Delete.
   IS-SCRUD provided for these, each in a cascade of code layers
   derived from the templates using $APP.php

   But Viewable page elements include:
   
     Command-bar: Without a row or search selected, these options:
     	         [Search -> Searcher], [Create New -> ShowRow
     	         +editable +new], [Read -> Reader] {nothing for
     	         update|delete since that prerequires a row to be
     	         selected so only in ShowTable}
		 
     Searcher: enable a search to be specified and initiated [Search+sql->ShowTable]
     Reader: specify a single row by id then [Read -> ShowRow]
     Show(sub)Table (with options to [Edit->showRow +editable -new]] or [Delete] a row)
     
     ShowRow (Modes: creating-new, editable; send update after edit
  	     approved [Save] once edited,) showRow +editable
  	     +new=with-default-values, lets user enter/change values
  	     and [Save] showRow -editable is for view only.  If
  	     permitted, allow to click [Edit] and become +editable.
	  
   And pages may include
     Command-bar for all
     Control area for Searcher, Reader to specify sql or row id and click [Search] or [Read]
     Data-View area for ShowTable, ShowRow

   Then the user can browse around and do what they want, triggering the SCRUD ops as applicable.

*/

// ********************************************************************************
//                                    globals
// ********************************************************************************


if (0) {
  // bootstrappy stuff from login.php for some handsome looks.  Turns out screen inefficient, so skipping.
  $headtxt = "";
  foreach (array("wrapper","container-fluid","row","col-md-12", "page-header") as $cl) {
    $headtxt .= "<div class=\"$cl\">\n";
  }
  $tailtxt = "";
  foreach (array("wrapper","container-fluid","row", "col-md-12") as $cl) {
   $tailtxt .= "</div>\n";
  }
  $ce = "class=\"form-example\"";   // bootstrapify form parts.
  $cg = "class=\"form-group\"";     // on a div comprising label, input, and span help-text
  $cc = "class=\"form-control\"";   // on <input>'s
  $cb = "class=\"help-block\"";     // on span help-text
  $cp = "class=\"btn btn-primary\""; // on submit button
  $cd = "class=\"btn btn-default\""; // on alternate A HREF link, styled hereby as a button
} else {
  $headtxt = $tailtxt = $ce = $cg = $cb = $cd = $cc = "";
  $cp = "class=\"btn btn-primary\""; // on submit button
  $br = "<BR>";
}

// ********************************************************************************
//                                 function defs
// ********************************************************************************

function showRow($id) {
    // get identified tx from DB and display contents.
    $i = 0;
    error_log("showRow(" . $id . ")",3,$erroutf);
    $row = getRow($id); // receives PHP returned object and makes a single-item display
    error_log("getRow(" . $id . ") returned $row",3,$erroutf);
    $showRow = "<table><TR>";
    forEach ($row as $key => $value) {
      $i++;
      if ($i % 6 == 0) { 
        $showRow .= "</TR><TR>\n";
      }      
      $showRow .= "<TD>$key</TD><TD>$value</TD>\n";
    }
    $showRow .= "</TR></table>\n";
    return $showRow;
}

function showTable($id) {
    // call for and receive PHP returned DB object; make the table;
    $row = getTable($id); // receives PHP returned object and makes a single-item display
    $showTable = "<table><TR>";
    $i = 0;
    forEach ($row as $key => $value) {
      $i++;
      if ($i % 6 == 0) { 
        $showTable .= "</TR><TR>\n";
      }      
      $showTable .= "<TD>$key</TD><TD>$value</TD>\n";
    }
    $showTable .= "</TR></table>\n";
    return $showTable;
}

function EnumSpec2Array($es) {
    // e.g., "ENUM('A','B','C')", but generalize for whitespace issues
    $res = explode(",",$es);                       // split into array
    $pfx = "ENUM";
    if (strtolower(substr($res[0],0,strlen($pfx)))==strtolower($pfx)) { // remove ENUM|enum prefix
       $res[0] = substr($res[0],strlen($pfx));
    }
    for ($i=0; $i<count($res); $i++) {            // trim whitepace & parens
      // echo $i . ": " . $res[$i]. " -> ";
      $res[$i] = trim($res[$i]," \n\r\t\v\x00()'");
      // echo $res[$i]. "<BR>\n";                    // trim whitepace & quotes from each
    }
    return $res;
}

function BuildSearchForm($cs) {
  global $ce,$cc,$cg,$cb,$cp, $headtxt, $tailtxt, $debug;;
  
  // HOWTO 01S index.php <form onsubmit="is_$APP_Search()" action="" method="POST">
  $sf = $headtxt . "<H1>Search Form</H1></div><P>\n"
      . "<FORM id=\"searchForm\" name=\"searchForm\" onSubmit=\""
   // . "alert('calling is_$APP_search()');"
      . "return is_$APP_search();\""
      . " action=\"\" "     // no action url, that is handled in the onsubmit
      . " method=\"POST\" "  // implies enctype="application/x-www-form-urlencoded", anyway it shows up on the server PHP as $_GET[...].
      . " >\n" // using onSubmit (click button or type <ENTER>) not action
      . "<input type=\"submit\" $cp value=\"Search!\">\n"
      . " <span $cb>[For all, search with no restrictions.]</span></div>\n";
  // a search form is a place to specify for each $colName
  //    if PRIMARY KEY, a comma-separated list, of hyphen-separated tx_id pairs
  //    if ENUM, one ENUM among the list
  //    if money or number or date or TIMESTAMP, a range of values
  //    if TEXT, a grep -i match

  // Thence in the corresponding form handler produce an SQL query with
  //  WHERE $colName= value AND $colName in range(a,b) AND $colName grep -i matches pattern...
  
  forEach ($cs["Columns"] as $col) {
      $colN = $col[0];      $colName   = $col[1];  $colType = $col[2];  $N = $col[3];
      $default = $col[4];   $InputType = $col[5];  $SQLType = $col[6];
      
      if        (strstr(strtolower($SQLType),strtolower("PRIMARY KEY")) ||
                 $InputType == "date"  || 
                 $InputType == "money" || 
                 $InputType == "number"   ) { // if money|number|date|TIMESTAMP: a value, range of values, or list of ranges
        $sf .= "<div $cg>$colN: <label for=\"$colName\"> $colType "
	    .  "</label>"
            .  "<input type=\"text\" $cc size=\"8\" maxlength=\"20\"><span $cb>Specify $colName "
	    .  " (one, range, or ranges as N, N-M, N-M,P-Q,...)</span> "
	    .  " </div>\n";
	    
      } else if ($InputType=="select" ||
                 strstr(strtolower($SQLType),strtolower("ENUM"))) { // if ENUM, one ENUM among the list
	$enumVals = EnumSpec2Array($SQLType);  // parse $SQLType as ENUM( + some number of enumvals + )
        $sf .= "<div $cg>$colN: <label for=\"$colName\">$colType </label>"
            . " <select $cc name=\"$colName\" id=\"$colName\">\n"
	    . "<div $ce >\n"
            . "<option value=\"\" selected></option>\n"
	    . "</div>\n";
	forEach ($enumVals as $enumVal) {
	  $sf .= "<div $ce >\n"
              .  "<option value=\"$enumVal\">$enumVal</option>\n"
	      .  "</div>\n";
	}
        $sf .= "</select><span $cb>Select $colName</span></div>$br\n";

      } else if ($InputType=="TEXT") { // if TEXT, send it over and create a grep -i match SQL query.
	$sf .= "<div $cg>" . $colN . ": <label for=\"$colName\"> $colType </label>\n"
            .  " <input type=\"text\" $cc id=$colName name=\"$colName\" size=10 maxlength=\20><span $cb>Specify $colName</span></div>$br\n";
	      
      } else {
        $sf .= "$colN: $InputType not searchable$br\n";
      }
  }
  $sf  .= "</form>\n" . $tailtxt;
  return $sf;
}

function indexOp($op,$id) { // carry out Op on indexed row ID. 
  global $erroutf;
  $ok    = 1;
  $table = "$APP";
  $sql   = "";
  if ($op=="SR" && permitted(priv::READ)) {
    $sql = "SELECT * FROM `$table` WHERE id=" . $id . ";";
  } else if ($op=="SD" && $id>=0 && permitted(priv::DELETE)) {
    $sql = "DELETE   FROM `$table` WHERE id=" . $id . " LIMIT 1;";
  }
  $link  = mysqli_connect('localhost', 
                         'tx_user', 
      	                 'Tedwasumpture', 
      	                 'tv');
  $ok = $ok && ($link);
  if ($ok) {
    mysqli_set_charset($link,  'utf8');
    $result = mysqli_query($link,$sql); // if SELECT then $result is a mysqli_result object, else TRUE or FALSE only.
  }
  $ok = $ok && $result;
  if (!$ok) { // false could be failed read.
    error_log("Connect or query failed; die with mysqli_error = " . mysqli_error($link) . "\n",3,$erroutf);
    die(mysqli_error($link)); // mysqli_close($link): can't call after die cuz we're dead.  Can't call before die() because mysqli_error won't work.
  }
  $N = mysqli_num_rows($result);
  mysqli_close($link);
  if ($op=="SR") {
    if ($N > 1) {
      error_log("Multiple rows ($N) received where 1 expected in indexOp($id)\n",3,$erroutf);
      $res = "";
    } else {
      $res = json_encode(mysqli_fetch_object($result));
    }
  }
  if ($op=="SD") {
    if ($result) {
       $res = "Delete on row $id was successful. Please continue via the main menu (you can re-do your SEARCH to see what's left.)\n";
    } else {
       $res = "Delete on row $id failed.\n";
    }
  }
  return $res;
}

function BuildDeleteForm($op,$id) {
  return indexOp($op,$id);
}

function BuildEditForm(  $cs,$op,$id) { return BuildRecordForm($cs,$op ,$id); }
function BuildCreateForm($cs        ) { return BuildRecordForm($cs,"SS", -1); }

function BuildRecordForm($cs,$op,$id) {
  global $ce,$cc,$cg,$cb,$cp, $headtxt, $tailtxt, $debug;;
  error_log("BuildRecordForm cs, $op $id\n",3,$erroutf);
  $cf = "";
  $editing = false;
  $cur = array();
  if ($op=="SE" && $id>-1) { // BuildEditForm;
     $editing = true;
     $ajson = indexOp("SR",$id); // read row id from DB.
     if ($debug) $cf .= $ajson;
     error_log("BuildRecordForm $op $ajson\n",3,$erroutf);
     $cur = json_decode($ajson,true);
     $fn  = "editForm";                       $flabel = "Edit Record Form";
     $is_APP_OP_fn = "is_$APP_update(".$id.")"; $divName="DataArea";
     $sublab = "Save Changes";                $m="PUT";
     $moretxt = " &nbsp;&nbsp;[Modify transaction details, then click Save Changes]";
  } else                   { // BuildCreateForm;
     $fn  = "createForm"; $flabel = "Create Form";      $is_APP_OP_fn = "is_$APP_create()";        $divName="DataArea"; $sublab = "Create Record";$m="POST";
     $moretxt = "[Enter transaction details, then click Create Record]";
  }
  
  // HOWTO 01CU index.php <form onsubmit="is_$APP_create(id,targetdiv)" action="" method="post">.
  // HOWTO 01CU Avoiding div id=isOPDiv + js:addOP(), use php:BuildOPForm() to keep $cs in PHP and determine placement. But use JS to handle/display results.

  $cf .= "<H1>" . $flabel . "</H1></div><P>\n"    // this /div ends the page-header div.
      . "<FORM id=\"" . $fn . "\" name=\"" . $fn . "\" onSubmit=\""
   // . "alert('calling " . $is_APP_OP_fn . "');"
      . "return " . $is_APP_OP_fn . ";\""
      . " action=\"\" "      // no action url, that is handled in the onsubmit
      . " method=\"$m\" "    // implies enctype="application/x-www-form-urlencoded", anyway it shows up on the server PHP as $_POST[...].
      . $ce . " >\n"         // using onSubmit (click button or type <ENTER>) not action
      . "<input type=\"submit\" $cp value=\"" . $sublab . "\"><span $cb>$moretxt</span>$br\n";
  forEach ($cs["Columns"] as $col) {
      $colN      = $col[0];
      $colName   = $col[1];
      $colType   = $col[2];
      $N         = $col[3];
      $default   = $col[4];
      $InputType = $col[5];
      $SQLType   = $col[6];
      $curval    = ($editing ? $cur[$colName] : "");
      
      if        ($InputType == "hidden") {
        // $cf .= $colN . ": Nothing for hidden input \"$colName\"$br\n";
        $cf .= "<div $ce >\n"
            . $colN . ": <label for=\""         . $colName . "\">   Hidden $colName value  of type $colType, value=$curval</label>\n"
            .  "<input type=\"hidden\" name=\"" . $colName . "\" id=\"" . $colName . "\" value=\"" . $curval . "\">\n" 
            .  "</div>$br\n";
	
      } else if ($InputType == "TEXT") {
          $cf .= "<div $cg >\n"
              . $colN . ": <label for=\""       . $colName . "\">   $colType </label>\n"
              .  "<input type=\"text\" $cc name=\"" . $colName . "\" id=\"" . $colName . "\" value=\"" . $curval . "\" required>\n" 
              .  "<span $cb>Enter $colName </span></div>$br\n";
	      
      } else if ($InputType == "select") {
          $cf .= "<div $cg >\n";
	  // parse $SQLType as ENUM( + some number of enumvals + )
	  $enumVals = EnumSpec2Array($SQLType);
	  $cf  .= $colN . ": <label for=\"" .   $colName . "\">" .  $colType . "</label>\n"
	        . " <select name=\""        .   $colName . "\" id=\""      . $colName . "\" required>\n";
	  forEach ($enumVals as $enumVal) {
	     $ss  = ($curval == $enumVal ? " selected " : "");
	     $cf .= "<div $ce >\n"
                  . "<option value=\"" . $enumVal . "\"" . $ss . ">" . $enumVal . "</option>\n"
		  .  "</div>\n";
	  }
          $cf .= "</select><span $cb>Select $colName</span></div>$br\n";
	  
      } else if ($InputType == "date") {
	  $cf .= "<div $cg>" . $colN . ": <label for=\"$colName\"> $colType </label>\n"
              .  " <input type=\"date\" id=$colName name=\"$colName\" value=\"" . $curval . "\"><span $cb>Specify $colName</span></div>$br\n";
	  
      } else if ($InputType == "money") {
          $ms = ($editing ? "value=\"" . $curval . "\"" : "placeholder=\"100.00\"");
	  $cf .= "<div $cg>" . $colN . ": "
	      . "<label for=\"$colName\">$colType</label>"
	      . " $<input type=\"text\" $cc id=\"$colName\" name=\"$colName\" " . $ms . " maxlength=\"9\" size=\"9\">"
	      . " <span $cb>Specify $colName</span></div>$br\n";
      } else {
        echo $colN . ": $InputType not handled$br\n";
      }
  }
  $cf .= "</form><P>\n" .  $tailtxt;
  return $cf;
}

function BuildReadForm($cs) {
  // a read form is a place to specify a single row id to look at.
  // Thence in the corresponding form handler produce an SQL query with 'WHERE $colName=value'
  // earlier we used <div isReadDiv></div> and (js)addRead() to put the form into that div.
  // but using $cs direct from $APP.php makes it easier done in PHP.
  global $ce,$cc,$cg,$cb,$cp, $headtxt, $tailtxt, $debug;
  
  // HOWTO 01R index.php <form onsubmit="is_$APP_read(id,targetdiv)" action="" method="get">
  
  $rf = $headtxt . "<H1>Read Form</H1></div><P>\n"
      . "<FORM name=\"readForm\" id=\"readForm\" "
      . " onSubmit=\""
   // . "alert('calling is_$APP_read(the_id=-1,divName=\'DataArea\')');"
      . "return is_$APP_read(the_id=-1,divName='DataArea')\" "
      . " action=\"\" "      // no action url, that is handled in the onsubmit
      . " method=\"get\" "  // implies enctype="application/x-www-form-urlencoded", anyway it shows up on the server PHP as $_GET[...].
      . $ce . " >\n"; // using onSubmit (click button or type <ENTER>) not action
  
  forEach ($cs["Columns"] as $col) {
      $colN = $col[0];      $colName = $col[1];
      // $colType = $col[2];      $N = $col[3];  $default = $col[4];
      // $InputType = $col[5];  These aren't needed in BuildReadForm, but used in other Build*Form()'s. 
      $SQLType = $col[6];
      
      if (strstr(strtolower($SQLType),strtolower("PRIMARY KEY"))) { // use can specify a single key row id.
        $rf .= "<div $cg>$colN: <label for=\"$colName\"> Specify row id value to read</label>"
	    . " <input type=\"text\" $cc id=\"$colName\" name=\"$colName\" maxlength=\"10\" size=\"10\"></div>$br\n";
      // } else {
      //   $rf .= "$colN: $colName, $colType, $InputType not selectable for single-row read.  Use Search instead.$br\n";
      }
  }
  $rf  .= "<input type=\"submit\" $cp value=\"Read Row\">\n"
       .  "</form><P>\n" . $tailtxt;
  return $rf;
   
}

// ********************************************************************************
//                      construct the page
// ********************************************************************************

//
//                      page top
//
  $myscriptsrc = "<script src=\"./isapi.js\"></script>\n<script type=\"text/javascript\" src=\"is$APP.js\"></script>\n"
               . "<link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.css\">\n"
	       . "<style type=\"text/css\">\nhtml { font-size: 100%; }\n</style>\n"; // ineffectual. 
  $myhtmltitle = $homehost / $APP";
  $mytitle     = "$APP";
  $feedbox_prompt = "Please report bugs & issues, offer comments & suggestions here.";
  include "scrudTop.php";

/*  isOPDiv with isAPP.js:addOP() no longer being used.
    <div id="isSearchDiv">isSearchDiv here</div> 
    <div id="isCreateDiv">isCreateDiv here</div> 
    <div id="isReadDiv">isReadDiv here</div> 
    <div id="isUpdateDiv">isUpdateDiv here</div>
    <div id="isDeleteDiv">isDeleteDiv here</div>
 */

  if (isset($_GET["op"])) { $op = $_GET["op"]; } else { $op = ""; } // set $op
  if (isset($_GET["id"])) { $id = $_GET["id"]; } else { $id = -1; } // set $id
  
if ($debug) {
  echo "testing.\n";
  echo "op set to [$op]<P>\n";
  if (isset($_SESSIO)) {                echo "_SESSION is set<BR>\n";
    if (isset($_SESSION["logged_in"])) { echo "_SESSION[logged_in] is set<BR>\n";
                                         echo "_SESSION[logged_in] is " . $_SESSION["logged_in"] . "<BR>\n";
  } } else { echo "_SESSION is not set<BR>\n"; }
}
//
//	                page parts
//
// Note: lbar.php exists in this case and has a fixed vertical task bar.
  
  $tt = "<center>&nbsp;<P>&nbsp;<P>Enter, edit, review receipts here.<P>\n"
      . "Select an action from the choices in the Operations Menu.<P>&nbsp;<P>&nbsp;</center>\n";
	      
  $cs = [ "Columns" =>  [
	    // [ col#, colName,    type,        N,    def,  InputType, SQL Type   ]
   	       [    1, "id",     "Number",    1,     -1,   "hidden", "INT AUTO_INCREMENT PRIMARY KEY"  ], 
	       [    2, "reporter", "By",        1,     "",   "select", "ENUM('CK','TV','TTS')" ],
	       [    3, "payer",    "From",      1,     "",   "select", "ENUM('A','B','C','R','WB','SVLLC','CK','Vendor')" ],
               [    4, "payee",    "To",        1,     "",   "select", "ENUM('A','B','C','R','WB','SVLLC','CK','Vendor')" ],
               [    5, "orig_payee","For",      1,     "",   "select", "ENUM('A','B','C','R','WB','SVLLC','CK','Vendor')" ],
               [    6, "amount",   "Dollars",   1,      0,    "money", "INT DEFAULT 0" ],
               [    7, "tx_class", "Enum",      1,     "",   "select", "ENUM('rent','PM fee','services','reimbursement','water_sewer')" ],
               [    9, "tx_desc","Description",20,     "",     "TEXT", "VARCHAR(40) CHARACTER SET utf8" ],
               [   10, "invoice", "Identifier",20,"YYMMX",     "TEXT", "VARCHAR(10) CHARACTER SET utf8" ],
               [   11, "date_due",      "Date", 1,     "",     "date", "DATE" ],
               [   12, "date_paid",     "Date", 1,     "",     "date", "DATE" ],
               [   13, "date_deposited","Date", 1,     "",     "date", "DATE" ],
               [   14, "created_at",    "Time", 1,   NULL,   "hidden", "TIMESTAMP DEFAULT CURRENT_TIMESTAMP" ],
               [   15, "updated_at",    "Time", 1,   NULL,   "hidden", "TIMESTAMP ON UPDATE CURRENT_TIMESTAMP" ],
        ]              ] ;

  if        ($op=="SS") { $ctrl = BuildSearchForm($cs); $data = "";                           
  } else if ($op=="SR") { $ctrl = BuildReadForm($cs)  ; $data = "";                           
  } else if ($op=="SE") { $ctrl = ""                  ; $data = BuildEditForm(  $cs,$op,$id); 
  } else if ($op=="SD") { $ctrl = ""                  ; $data = BuildDeleteForm(    $op,$id); 
  } else if ($op=="SC") { $ctrl = BuildCreateForm($cs); $data = "";        
  } else                { $ctrl = "" ;   $topTxt = $tt; $data = "";  // default.
  }
  /* At one point I thought the operations should be doubled with separate Start Op and Handle Op operations,
   * the first to provide a UI in which the user might specify how exactly to do the op,
   * and the second to show the results. Thus S* and H* op codes.
   * However, the results are generated by AJAX or index.php itself, so we don't need a separate Op
   * code on the index form-building side.  Instead the results are put together and shown by, typically,
   * the gotPut() function called by the onload of an AJAX call stack.
   * So these early ideas can be skipped:
  if ($op=="HS") { $ctrl = BuildSearchForm($cs); $data = showTable($whereStr); }
  if ($op=="HR") { $ctrl = BuildReadForm($cs)  ; $data = showRow($id); }
   * Maybe later if you want to redisplay a re-executed search result table along with a delete or edit/save action result,
   * you might start here again.
   */
   
  // spit it out.

  // Top text
  echo $topTxt;
  if ($debug) echo "Control = $ctrl<P>Data = $data<P>\n";
  
  // control area
  if ($centerareas) echo "<center>";
  echo "<table class='o' width=100%><tr><td><div id=ControlArea>";
  if (isset($ctrl) && $ctrl) {
    echo $ctrl;
  } else {
    echo "<center>";
    for ($i=0;$i<2;$i++) echo "&nbsp;<P>";
    echo // "\nEmpty ControlArea. <BR>"
         "Choose an action from the Operations Menu.\n";
    for ($i=0;$i<3;$i++) echo "&nbsp;<P>";
    echo "</center>";
  }
  echo "\n</div></td></tr></table>";
  if ($centerareas) echo "</center>";
  echo "<P>\n";
  
  // data area
  if ($centerareas) echo "<center>";
  echo "<table width='100%' class='o'><tr><td>";
  if (!isset($data) || !$data) echo "<center>";
  echo "<div id=DataArea>";
  if (isset($data) && $data) {
    echo $data;
  } else { 
    for ($i=0;$i<2;$i++) echo "&nbsp;<P>";
    echo "\n(No Data)\n";
    for ($i=0;$i<3;$i++) echo "&nbsp;<P>";
  }
  echo "\n</div>";
  if (!isset($data) || !$data) echo "</center>";
  echo "</td></tr></table>";
  if ($centerareas) echo "</center>";
  echo "<P>&nbsp;<P>\n";

  // bottom.
  $myuri  = "is/$APP/index.php";
  $myfrom = "bottom";
  $mycopyrightyears = "2000 - 2023";
  $mychangedates = "Created: May 20, 2023; Modified: May 21,25, 2023";
  include "/var/www/shared/mybot.php";
  
 ?>
EOD;

