<?php include "/var/www/shared/local.php"; ?>
<?php
  //
  // isphp.php (PHP generating PHP)
  //

  /* This program uses an IS data structure (in $NAME.php) to
     autogenerate a PHP-includeable library/function file that provides
     an authenticated server API to those SQL CRUD operations on
     server's DB returning CRUD results to client.

     To use it:
     % php isphp.php $NAME

   */
  /* Bug trail:

   x learn to use error_log()
   x condition $_POST, $input on having it set
   x Handle nonexistent REQUEST_METHOD (when called on command-line)
   x add $link arg to mysqli_error().
   x Table tv.Test doesn't exist. got isTest.db create_table to work.
   x added data to xhr.send().
   x with Content-type: application/json headers reading the php://input produces a string.
   x Again php Test/isTest.php says Table tv.Test doesn't exist: Test/isTest.db create_table yet again!
   x input an Object unless json_decode(..,TRUE).  Fixed.
   x empty query, sql undefined: edge case found and replaced with a Delete op
   x figured out how to get data into the server code: json_decode(file_get_contents(php://input))
   x syntax errors for make tc
   x  mysqli_query returns "1"  (and row is created) but mysqli_info() returns NULL.
   x syntax errors for make tr
   x syntax errors for make tu
   x syntax errors for make td
   x curl works but a form from a browser doesn't (had to clean up the output and make good json on return)
   x how? after isTest.php we get Navigated to /?<form-data>
   x	since trying to send JSON, set header for application/json
   x	also since JSON, upon failure to get approval, it backs up,
   x	     re-encodes JSON as overwritten URL ?a=b&c=d..\
   x	     and tries again but breaking the URL.
   x CRUD ops don't have data from curl.
   x make tr -> GET&SELECT WHERE id=-1, but pulls out something that is id=-1!
   x figured out the URL the form hits via Makefile curl
   x figured out where it hits it, isphp.php|isTest.php
   x hoping it gets results back from echo on the server php.
   x test.data.update had an id specified. But can you set an id for a specified row which already has an id? Yes.
   x fixed. make tu: isTest.php recieves a POST and the ill-formed record, so json_decode result is empty &c.
   x don't know how to get data back from the server code to the client
   x   Wondering how to get the results into the client: in the form in isjs.php is_$app_$op() or something.
   x    solution: clean output written via echo in the server php code.
   x how? after isTest.php we get Navigated to tomveatch.co
   x   first it's xhr.send(l) to isTest.php; then into lala land.
   x   sql undefined isTest.php line 87.
   x UI for Create should let you put in info to go into the fields.
   x UI for Read should let you pick from an existing row id.
   x   Let's do Search later and just do Read for now, and let's assume Read requires a row id only.
   x   So the initial UI is a numeric field to put in your own row id,
   x   and the result is displayed in some default display format for a record based on is.php:Columns.
   x UI for Update should, as for Create, let you put in info to go into the fields.
   x   Update should first be select row by ID to edit, then a Read it by ID, then a
   x   display of everything editably, then an Update button then a display with a Saved dressing on the button,
   x    then if more editing occurs, rename the button Update/Save again and let it continue.
   x UI for Delete should either show all the existing rows to pick one or more to delete,
   x    or it should let you put in a number.
   x Return results for delete should include SUCCESS, FAILURE, and Row Didn't Exist In The First Place.
   x accessing isCorona.php with json data correct fails and somehow pulls index.php?bla=bla?encoded=as+url
   x  which then fails with headers not set properly, apparently.
   x  becausee isCorona.php is an empty file!
   x  // the onsubmit function should end with "return false;" to prevent additional submit handling.
   */
  $debug=1;
  if (defined('STDIN')) { $NAME=$argv[1];      /* Run this script on the command line and give the app name as an argument. */ }
  else                  { $NAME=$_GET['NAME']; }
  include "$NAME/$NAME.php";

  echo "<?" . "php \n";
?>
  require "/var/www/shared/lib.php"; // for permitted()
  
  //
  // This PHP program was generated by php isphp.php <?php echo $is['Name'];?> or isphp.php?NAME=<?php echo $is['Name'];?> 
  // and provides an IS API to the DB <?php echo $is['DBName'];?> for table <?php echo $is['TableName']; ?> 
  //

  // The URL of this program provides a REST-ish API on HTTP requests with JSON data in the HTTP message body.
  // The HTTP method GET|PUT|POST|DELETE determines the REST function READ/SEARCH|UPDATE|CREATE|DELETE.
  // (previous draft had the table and operation in the URL as &is=$tablename&$op=S|C|R|U|D.
  
/* Second Draft: use php_crud_api approach: use HTTP METHOD to (mostly) select
 * CRUD op, and direct mysql calls in here.  Mostly, because SEARCH is conceptually a retrieval like READ thus a GET,
 * but SEARCH params should not be in the URI revealed to all, but in the JSON body, slightly more secure,
 * and JSON bodies go in POST requests which are not in general safe or idempotent, though SEARCH is both.
 */

/*
 * Phase 1: get ready.
 */
$debug  = 0;
$erroutf = "./isphp.err";
$method = (isset($_SERVER["REQUEST_METHOD"]) ? $_SERVER["REQUEST_METHOD"] : "NONE");
error_log("method=$method\n",3,$erroutf);
$cli = false;
if (php_sapi_name() === 'cli') {
  $cli = true;
  echo "Running PHP as cli.<BR>\n";
} else {
  $h      = apache_request_headers(); // getallheaders() killed PHP.
  $s      = "";
  foreach ($h as $hdr => $hval) {
    $s .= "$hdr: $hval\n";
  }
  if ($debug) error_log ( "headers: $s\n",3,$erroutf);
}

  // HOWTO 07 is<?php echo $is[TableName]; ?>.php server checks method (OPTIONS, GET, PUT, POST, DELETE)
if ($method=="OPTIONS" && !$cli) {
  http_response_code(200); // 200 OK, or 204 No Content.
  header("Accept: GET,PUT,POST,DELETE,OPTIONS");
  header("Access-Control-Allow-Origin: <?php echo $is['URL'];?>");
  header("Access-Control-Allow-Methods: GET,PUT,POST,DELETE,OPTIONS");
  header("Access-Control-Allow-Headers: access-control-allow-methods, access-control-allow-origin, Content-Type, Accept, Origin,");
  exit(0);
}

$request  = (isset($_SERVER['PATH_INFO']) && $_SERVER['PATH_INFO']!=""
          ? explode('/', trim($_SERVER['PATH_INFO'],'/')) 
          : "" );
	  
// echo "_REQUEST: "; var_dump($_REQUEST);
// echo "_GET: "    ; var_dump($_GET);
// echo "_POST: "   ; var_dump($_POST);

function var_error_log($prefix,$object=null,$suffix) {
  global $erroutf;
  // log contents of the result of var_dump( $object )
  ob_start();                    // start buffer capture
  var_dump( $object );           // dump the values
  $contents = ob_get_contents(); // put the buffer into a variable
  ob_end_clean();                // end capture
  error_log("$prefix $contents $suffix",3,$erroutf);        
}

  // HOWTO 08 is<?php echo $is[TableName]; ?>.php grabs json if any
$phpinput = file_get_contents('php://input',true);
error_log ( "php://input=" . ($phpinput==""?"empty":$phpinput) . "\n",3,$erroutf);
$input    = ($phpinput!="" ? json_decode($phpinput,1) : NULL);

function errdie($msg) {
  global $erroutf;
  $res= "{'rows_affected':'0','result':'FAILED','msg':'$msg'}\n";
  error_log($res,3,$erroutf);
  echo "$res";
  die($res);
}

function grab($lbl) {
  global $_GET, $input;
  if (isset($_GET[$lbl])) {
    $res = $_GET[$lbl];  
  } else if (isset($input[$lbl])) {
    $res = $input[$lbl];
  } else {
    $res = "";
  }
  return $res;
}

$id = grab("id");    // none is a good answer.
$op = grab("op");    // S for SEARCH, C for CREATE, U for UPDATE, none (id=$id) for READ

unset($input["op"]); // Don't send op to sql.
foreach ($input as $key => $value) {  // Don't send empty values to sql (e.g, updated_at, created_at..)
  if (!$value) {
    unset($input[$key]);
    error_log("removing input value \"$value\" for key $key\n",3,$erroutf);
  }
}

error_log("op=" . $op . ", id=" . $id . "\n", 3, $erroutf);

if (!$input) {
  if ($phpinput=="") {
    error_log("No input available from php://input\n",3,$erroutf);
  } else {
    error_log("Input not decodeable as valid JSON (after removing op & empty key/values: $phpinput->$input.\n",3,$erroutf);
  }
} else {
  if ($method == 'POST' && isset($input['id'])) { // Handle an unlikely error condition.
    errdie("Error: POST (create|search) request has 'id' $input[id]. A new DB entry has no id beforehand.  For a specific ID use GET with id=id.\n");
  }
}
if ($method == "PUT" && ($op!="U" || $id < 0)) {
    errdie("Error: PUT (update) request lacks op=U or id>0.  Update requires correct op command and a valid row id.\n");
}

  // HOWTO 09 is<?php echo $is[TableName]; ?>.php connects to mysql on localhost
// connect to the mysql database
$link     = mysqli_connect('localhost', 
     		           '<?php echo $is['User'];?>', 
      	                   '<?php echo $is['Pwd'];?>', 
      		           '<?php echo $is['DBName'];?>');
mysqli_set_charset($link,'utf8');
 
// retrieve the table and key from the path
$table    = "<?php echo $is['TableName']; ?>"; // was preg_replace('/[^a-z0-9_]+/i','',array_shift($request));

if ($method=="POST") {
  if (isset($_POST)) { // only for POST method
    error_log("_POST: [" . join(":",array_keys($_POST)) . "]=>[" . join(":",array_values($_POST)) . "]\n",  3,$erroutf);
  } else if (isset($input) && $input) {
    error_log("Using input not _POST.  input=" . $input . "\n",3,$erroutf);
  } else {
    error_log("_POST not set; input not set or empty.\n",3,$erroutf);
  }
  
  // HOWTO 10C is<?php echo $is[TableName]; ?>.php builds a POST (create) query
  // only for INSERT
  // get all the entries in the table from the input JSON 
  // escape the columns and values from the input object
  $columns = ((isset($input) && $input != NULL)
           ? preg_replace('/[^a-z0-9_]+/i','',array_keys($input))
           : [] );
  $values  = ((isset($input) && $input != "")
           ? array_map(function ($value) use ($link) {
	         if ($value===null) return null;
	         return mysqli_real_escape_string($link,(string)$value);
	       },array_values($input))
	   : [] );
  /* was: 
     $columns = preg_replace('/[^a-z0-9_]+/i','',array_keys($input));
     $values = array_map(function ($value) use ($link) {
       if ($value===null) return null;
       return mysqli_real_escape_string($link,(string)$value);
     },array_values($input));
   */ 

  // build the SET part of the SQL command for a POST/UPDATE 
  $set = '';
  $j=0;
  for ($i=0;$i<count($columns);$i++) {
    if ($columns[$i] != 'id') { // Exclude the id column
      $set.=($j>0?',':'').'`'.$columns[$i].'`=';
      $set.=($values[$i]===null?'NULL':'"'.$values[$i].'"');
      $j++;
    }
  }
}

if ($method == "PUT") {
  // HOWTO 10U is<?php echo $is[TableName]; ?>.php builds a PUT (update) query
  // given PUT, we know $op == "U" && $id >= 0.  Build the (key=value)* part of the sql statement.
  $updata = "";
  $comma  = "";
  foreach ($input as $key => $value) {  // input should lack hidden InputType entries (cf <?php echo $is[TableName]; ?>.php)
    if ($key != "id" && $key != "op") {
      $updata .= $comma . "`$key` = \"$value\"";
      $comma = ", ";
    }
  }
}

// create SQL based on HTTP method
$sql = ""; // empty oughta do nothing, which is desireable if the requested operation is not permitted.
switch ($method) {
  // known-single-row read or delete: row id is in the uri.
  // known-single-row update:         row id is in input (json)
  // unknown-row create or search:    row id is unspecified (neither in uri nor input body json)

  // HOWTO 11 is<?php echo $is[TableName]; ?>.php branches on HTTP method, in case of NONE, uses SELECT * or select where id=n
  case 'NONE':   // Get last inserted id. 
    $method="GET";
    $rowid=mysqli_insert_id($link); // if none found, mysqli_insert_id returns 0 which drops through and selects all rows.
    if ($rowid==0 && permitted(priv::READ)) {
      $sql = "SELECT * FROM `$table`;";
    } else if (permitted(priv::READ)) {
      $sql = "SELECT * FROM `$table` WHERE id=" . $rowid . ";";
    } 
    error_log("method='NONE': changing to a GET for row id $rowid\n",3,$erroutf);
    break;

  // HOWTO 12U is<?php echo $is[TableName]; ?>.php or PUTs with UPDATE table SET .. where ..
  case 'PUT':
    // Update (PUT=store something at a given place (since id must therefore be known, this is an UPDATE))
    // respond with 200 OK.  Parse Content-* headers or reply with 501 Not Implemented.  
    // already checked, given PUT, that $op=="U" && $id >= 0.  So go ahead and use those assumptions.
    if (permitted(priv::UPDATE)) {
      $sql = "UPDATE `$table` SET $updata WHERE `id` = $id;";
    } 
    break;
    
  // HOWTO 13 is<?php echo $is[TableName]; ?>.php or POSTs by an INSERT into table columns values..
  case 'POST': // SEARCH as specified or
       	       // Create (POST=put something subordinate to, into the DB, thus a new id, this is a CREATE)
       	       // reply with 201 Created + entity with id + Location: header.
    if ($op=="C" && permitted(priv::CREATE)) {
      $sql = "INSERT INTO `$table` (`" . implode("`,`",$columns) ."`) VALUES ('" . implode("','",$values) . "');";
    } else if ($op=="S" && permitted(priv::SEARCH)) {
      $sql = "SELECT *  from `$table` ";
      $sep = "";
      $needsWhere = 1;
      foreach($input as $key => $value) {
         if ($key != "op") {
           if ($needsWhere) {
             $sql .= " WHERE ";  // empty search means select * without a where clause.
  	     $needsWhere = 0;
           }
           $sql .= $sep    . "`" . $key . "` = \"" . $value . "\"";
 	   $sep  = " AND ";
         }
      }
      $sql .= ";\n";
    } else {
      error_log("is<?php echo $is[TableName]; ?>.php handling POST but no op specified in URL or JSON (should say op=S or op=C).\n",3,$erroutf);
    }
    error_log("is<?php echo $is[TableName]; ?>.php has created sql=$sql for this POST request.\n",3,$erroutf);
    break;

  // HOWTO 14 is<?php echo $is[TableName]; ?>.php or DELETEs by SQL DELETE FROM ...
  case 'DELETE': // Delete
    if (is_array($_GET) && isset($_GET['id']) && $_GET['id'] != NULL && permitted(priv::DELETE)) {
      $rowid=$_GET['id'];  // HTTP delete request has empty body so row id is in the URI as ...?id=3
      $sql = "DELETE FROM `$table` WHERE id=" . $rowid . ";";
      break;
    } else if ($input != NULL && isset($input['id']) && $input['id'] != NULL && permitted(priv::DELETE)) {
      // atypical use with {"id":N} in the json body, but we'll handle it.
      $rowid = $input['id'];
      $sql = "DELETE FROM `$table` WHERE id=" . $input['id'] . ";";
      break;
    } else {
      error_log("DELETE: $_GET lacks id field.\n",3,$erroutf);
    }
    // drop through

  // HOWTO 15 is<?php echo $is[TableName]; ?>.php GET by ?id=$id => SELECT * FROM TABLE WHERE id=$id;
  case 'GET':    // Read single-row or search as specified or for all
  default:       // default is get
  
    if (permitted(priv::READ)) {
      if (is_array($_GET) && isset($_GET['id']) && $_GET['id'] != NULL) { // ok, this is normal.
        // GET without input json body is a single-row read on URI-specified id.
        $rowid = $_GET['id'];
        $sql = "SELECT * FROM `$table` WHERE id=" . $_GET['id'] . ";";
      } else if ($input != NULL && isset($input['id']) && $input['id'] != NULL) {
        // atypical use with {"id":N} in the json body, but we'll handle it.
        $rowid = $input['id'];
        $sql = "SELECT * FROM `$table` WHERE id=" . $input['id'] . ";";
      }
    }

    if (permitted(priv::SEARCH) && $sql == "") {
      if ($input != NULL && isset($input['search']) && $input['search'] != NULL) { // probably a bug; we SEARCH by POST
        // GET with input json specifying search: {"search":"$search_string"}
        $rowid = 0;
        $sql = "SELECT * FROM `$table` WHERE " . $input['search'] . ";";
      } else if (is_array($_GET) && isset($_GET['search']) && $_GET['search'] != NULL) { // probably a bug; we SEARCH by POST
        // GET with URI-appended ?search=..  (JSON body deprecated {"search":"$search_string"})
        $rowid = 0; // might be an error if search string has id=N. 
        $sql = "SELECT * FROM `$table` WHERE " . $_GET['search'] . ";";
      } else {
        // GET specified but no row or search specified so ask for all.
        $rowid = 0;
        $sql = "SELECT * FROM `$table`;"; // all.
      }
    }
    error_log("method: $method: $sql\n",3,"/tmp/isphp.err");
    break;
}
error_log("created sql for method: $method, op: $op, id: $id, sql: $sql\n",3,$erroutf);

/*
 * Phase 2: Do The Query
 */
// execute SQL statement
  // HOWTO 16 is<?php echo $is[TableName]; ?>.php mysqli_query() execute the SQL statement
$result = mysqli_query($link,$sql); // if SELECT then $result is a mysqli_result object, else TRUE or FALSE only.

/*
 * Phase 3: Process the result and return or die as appropriate.
 */
if (!$result) { // false could be failed delete, failed insert, or failed read.
  // HOWTO 17 is<?php echo $is[TableName]; ?>.php die on failure
  $es = " mysqli_query(sql)=FALSE: " . mysqli_error($link) . ", w/sql: $sql\n";
  // console.log($es); this code is run on the server, output is not seen on client browser.
  error_log($es,3,$erroutf);

  // die if SQL statement failed
  http_response_code(404);
  error_log("No result, die with mysqli_error = " . mysqli_error($link). "\n",3,$erroutf);
  die(mysqli_error($link)); // mysqli_close($link): can't call after die cuz we're dead.  Can't call before die() because mysqli_error won't work.
}

$rs = print_r($result,TRUE);
error_log("mysqli_query() returned \"{$rs}\" on sql: $sql\n",3,$erroutf);

// print some results like the id of the inserted/deleted row, the updated row id, the row itself
if ( $method == 'GET' ||                // GET implies (single-row) retrieve
    ($method == 'POST' && $op=="S")) {  // POST & op=SEARCH, multi-retrieve
  // HOWTO 18R,S is<?php echo $is[TableName];?>.php packages up retrieved results from single-row GET or POST+op==SEARCH as json_encode of the fetched object
  $res = "";
  if (!isset($rowid) || !$rowid) $res .= '['; // if no rowid is set, this may be for multiple rows, so start an array of JSON objects
  $N = mysqli_num_rows($result);
  for ($i=0;$i<$N;$i++) {
    $res .= ($i>0?',':'').json_encode(mysqli_fetch_object($result));
  }
  if (!isset($rowid) || !$rowid) $res .= ']';
  error_log($method . " result: $res\n",3,$erroutf);
  header("Access-Control-Allow-Origin: *");
  header("Content-Type: application/json; charset=utf-8");
  http_response_code(200); // OK
}

elseif ($method=="POST" && $op!=SEARCH) { // aka POST with body is an INSERT aka CREATE (SEARCH was handled above)
  // HOWTO 19C is<?php echo $is[TableName];?>.php POST/INSERT as custom json
  $res = "{";
  // handle reported stats for a POST/INSERT
  // for multi-line POST/INSERTs we can find out a bit about how it went with mysqli_info(). 
  $str = mysqli_info($link);
  // Unless multiple inserts at a time, $str will report No results. 
  error_log("Called mysqli_info() recieved: $str.\n",3,$erroutf);
  preg_match_all ('/(\S[^:]+): (\d+)/', $str, $matches);
  $info = array_combine($matches[1], $matches[2]);
  if ($info==NULL) {
    if ($debug) error_log("No results from mysqli_info() (expected given this is a one-row UPDATE)\n",3,$erroutf);
    error_log("Expecting 1 and got: " .     mysqli_affected_rows($link) . " row(s) affected\n",3,$erroutf);
  } else {
    if ($debug) var_error_log("info is not null: ",$info,"\n");
    if (isset($info['Records'])) {
        error_log("HTTP POST, mysql INSERT modified " . $info['Records'] . " rows.\n",3,$erroutf);
	$res .= "\"Records\":\"" . $info['Records'] . "\",";
    }
    if (isset($info ['Duplicates']) && $info['Duplicates'] != 0) {
        error_log("HTTP POST, mysql INSERT found " . $info['Duplicates'] . " duplicate rows.\n",3,$erroutf);
	$res .= "\"Duplicates\":\"" . $info['Duplicates'] . "\",";
    }
    if (isset($info['Warnings']) && $info ['Warnings'] != 0) {
        error_log("HTTP POST, mysql INSERT generated " . $info ['Warnings'] . " warnings.\n",3,$erroutf);
	$res .= "\"Warnings\":\"" . $info['Warnings'] . "\",";
    }
  }

  // reply with 201 Created + the entity id + maybe a Location: header if RESTish.
  http_response_code(201);
  $mar = mysqli_affected_rows($link);
  error_log("Expecting 1 and got: $mar row(s) affected\n",3,$erroutf);
  $miid = mysqli_insert_id($link);
  // id is the auto-incremented, new, row id for the inserted row.
  // rows_affected should be 1 for 1 new row.
  // result should be TRUE for success, otherwise we died before we got here. Just being helpful.
  error_log("id of " . ($method=="POST"?"inser":"upda") . "ted row is: $miid\n",3,$erroutf);
  header("Access-Control-Allow-Origin: *");
  header("Access-Control-Allow-Methods: *");
  header("Content-Type: application/json; charset=utf-8");
  $res .= "\"id\":\"$miid\",\"rows_affected\":\"$mar\",\"result\":\"$result\"}\n"; // get ready to report home
}

elseif ($method == 'PUT') { // aka UPDATE
  // HOWTO 19 is<?php echo $is[TableName];?>.php PUT result should be merely a header 200 OK but some informative summary is put into json
  $res = "{";
  // handle reported stats for a PUT/UPDATE
  // for multi-line PUT/UPDATEs we can find out a bit about how it went with mysqli_info().
  $str = mysqli_info($link);
  /* Unless multiple updates at a time, $str will report No results. */ 
  error_log("Called mysqli_info() recieved: $str.\n",3,$erroutf);
  preg_match_all ('/(\S[^:]+): (\d+)/', $str, $matches);
  $info = array_combine($matches[1], $matches[2]);
  if ($info==NULL) {
    error_log("No results from mysqli_info() (expected given this is a one-row UPDATE)\n",3,$erroutf);
    error_log("Expecting 1 and got: " .     mysqli_affected_rows($link) . " row(s) affected\n",3,$erroutf);
  } else {
    if ($debug) var_error_log("info is not null: ",$info,"\n");

    if (isset($info['Rows matched'])) {
        error_log("HTTP PUT, mysql UPDATE matched " . $info['Rows matched'] . " rows.\n",3,$erroutf);
	$res .= "'Rows matched':" . $info['Rows matched'] . ",";
    }
    if (isset($info['Changed'])) {
        error_log("HTTP PUT, mysql UPDATE changed " . $info['Changed'] . " rows.\n",3,$erroutf);
	$res .= "'Changed':" . $info['Changed'] . ",";
    }
    if (isset($info['Warnings'])) {
        error_log("HTTP PUT, mysql UPDATE generated " . $info ['Warnings'] . " warnings.\n",3,$erroutf);
	$res .= "'Warnings':" . $info['Warnings'] . ",";
    }
  }
  $res .= "}";
  // respond with 200 OK. Parse Content-* headers or reply with 501 Not Implemented.  
  header("Access-Control-Allow-Origin: *");
  header("Content-Type: application/json; charset=utf-8");
  http_response_code(200);
}

elseif ($method == 'DELETE') { 
  // HOWTO 20 is<?php echo $is[TableName];?>.php DELETE is a json with id and result code.
  header("Access-Control-Allow-Origin: *");
  header("Content-Type: application/json; charset=utf-8");
  http_response_code(200);
  $res= "{\"id\":\"$rowid\",\"result\":\"$result\"}\n"; // get ready to report home
       // result should always be TRUE since we checked $res and died earlier on failure.
       // probably if the row was already deleted then it will seem to be TRUE
       //    even though it wasn't quite SUCCESS in deleting a row.
}

else {
  error_log("Unrecognized method: $method. Not going to respond\n",3,$erroutf);
  $res = "";
}

  // HOWTO 21 is<?php echo $is[TableName];?>.php finally just echoes the result and closes mysqli. Done on the server.
error_log("$method response is: $res",3,$erroutf);
echo "$res"; // report to client (actual output here)

// close mysql connection
mysqli_close($link);

<?php
  echo "?" . ">";
 ?>
